library(rgdal)
library(raster)
library(statmod)

source('G://dickBrusData/postParams/postParams.R')
source('G://dickBrusData/postParams/averageCov.R')

### define zbar, Xc, 

N=dim(Xc)[[1]]
p=dim(Xc)[[2]]

#########################################
### set ranges for cov params and trend params
#########################################
### set ranges for beta using OLS...
if (p > 0){
  betaTmp <- solve(t(Xc) %*% Xc , t(Xc) %*% zbar)
  sigma2Tmp <- sum((zbar- Xc %*% betaTmp) ^ 2) / (dim(Xc)[[1]] - dim(Xc)[[2]])
  vbetaTmp <- as.numeric(sigma2Tmp) * diag(solve(t(Xc) %*% Xc))
  stdNrm <- seq(-14 , 14 , 0.05)
  betaMat <- kronecker(betaTmp , matrix(1 , 1 , length(stdNrm))) + 
    kronecker(matrix(sqrt(vbetaTmp) , length(betaTmp) , 1) , matrix(stdNrm , 1 , length(stdNrm)))
}else{
  betaMat <- c()
}                 

############################################################
### prioraType = 'uni' or 'invgamma' 
### for uni specify lb and ub
### for invgamma specify alpha (shape) and beta (scale) 
############################################################
prioraType = 'uni'
prioraPars = c(0.5 , 150)

############################################################
### prior for c1 is invgamma (no need to specify)
### specify params...
############################################################
priorc1Pars = c(0 , 0) # prop to 1 / c1
#priorc1Pars = c(-1 , 0) # uni for c1

c1Vec <- seq(0 , 50 , 0.1) 
aVec = c(seq(0 , 5 , 0.1) , 6:20)

####################################################
### a set-up function...
### enter either discPts (list of matrices/dfs) or areas (spdf), not both
### if only areas1 or discPts1 is entered, assumed symmetric cov mtx rqd. 
### type is method of sampling disc pts (try 'random' or 'stratified'; see doc of spsample function).
### nQuadPts only used if doing some form of quadrature
### nSamples = number of disc pts
### method is method of approx for av covs, see top of averageCov.R
####################################################
### DMats.a2a <- DMats4AverageCov.a2a(areas1 = NULL , areas2 = NULL  , discPts1 = NULL , discPts2 = NULL , nQuadPts = 7 , nSamples = 100 , method = 'lq' , type = 'random')



####################################################
### function to compute posterior distributions. 
### will take DMats.a2a from main script.
### not yet updated prediction to use new methods of computing average covariances.
####################################################
### postParams <- postc1abetaz0(z = zbar , X = Xc , aVec = aVec , c1Vec = c1Vec , betaMat = betaMat)


