refPriora <- function(a , X, DMats, intLikbObj , covModel = 'ExponentialC' , nu = 0.5){
  ##################################
  ### reference prior for a, from Berger, De Oliveia and Sanso, JAMSA...
  ### intLikbObj contains terms rqd: Ac, invA, invAX, inv(XinvAX)
  ##################################
  N <- dim(X)[[1]]
  p <- dim(X)[[2]]

  
  if(covModel == 'MaternC' & is.element(DMats$method , c('lq' , 'lq.dp4diag')))
  { 
    stop('Time to write the function ddMaternC_wrta_wrth to make code work!' ) 
   } else {}
  
  if (a > 0){
    if (missing(intLikbObj)){
      stop('Error - define intLikbObj before calling the refPriora function!')
    }else{}

    Ac <- intLikbObj$Ac
    
### for the exponential covariance function...    
#    dAda <- Ac * Dc / (a ^ 2) ### THIS WAS WRONG, KEPT HERE FOR NOW JUST IN CASE NEED TO COMPARE (08/10/18)!
#    dAda <- averageCov(covModel = paste0('d' , covModel , '_wrta') , covPars = c(1 , a) , DMats = DMats.a2a , nu = nu)
     dAda <- averageCov(covModel = paste0('d' , covModel , '_wrta') , covPars = c(1 , a) , DMats = DMats , nu = nu)

     
    if (missing(intLikbObj)){
      tmp <- lndetANDinvCb(Ac , X)
      invA <- chol2inv(tmp$cholC)
      invAX <- tmp$invCb
      XinvAX <- t(X) %*% invAX
      
      tmp <- lndetANDinvCb(XinvAX , t(invAX))
      TauMatXA <- invAX %*% tmp$invCb
      
      TA <- invA - TauMatXA
    }else{
      TA <- intLikbObj$invA - intLikbObj$invAX %*% intLikbObj$invXinvAX %*% t(intLikbObj$invAX) 
    }
    
    #TATA <- TA %*% TA
    Wa <- dAda %*% TA
    #WaTA <- Wa %*% TA
    WaWa <- Wa %*% Wa
    
    #trTA <- sum(diag(TA))
    #trTATA <- sum(diag(TATA))
    trWa <- sum(diag(Wa))
    #trWaTA <- sum(diag(WaTA))
    trWaWa <- sum(diag(WaWa))
    
    arg2 <- (N - p) * trWaWa - trWa ^ 2
    if (arg2 > 0){
      prior_a <- 0.5 * log(arg2)
    }else{
      prior_a <- -Inf
    }
    
  }else{
    prior_a <- -Inf
  }
  
  return(prior_a)
}




refPriora_PT.TEST <- function(a , X, Dc , covModel = 'ExponentialC' , nu = 0.5){
##################################
### reference prior for a, from Berger, De Oliveia and Sanso, JAMSA...
### intLikbObj contains terms rqd: Ac, invA, invAX, inv(XinvAX)
##################################
  N <- dim(X)[[1]]
  p <- dim(X)[[2]]
  
  if (a > 0){
### for the exponential covariance function...    
#    Ac <- exp(-Dc / a)
#    dAda <- Ac * Dc / (a ^ 2) 

    fnCallStr <- paste0(covModel , '(Dc , a , nu)')
    Ac <- eval(parse(text=fnCallStr))
      
    fnCallStr <- paste0('d' , covModel , '_wrta(Dc , a , nu)')
    dAda <- eval(parse(text=fnCallStr))
    
    tmp <- lndetANDinvCb(Ac , X)
    invA <- chol2inv(tmp$cholC)
    invAX <- tmp$invCb
    XinvAX <- t(X) %*% invAX
      
    tmp <- lndetANDinvCb(XinvAX , t(invAX))
    TauMatXA <- invAX %*% tmp$invCb
      
    TA <- invA - TauMatXA

    Wa <- dAda %*% TA
    WaWa <- Wa %*% Wa
    
    trWa <- sum(diag(Wa))
    trWaWa <- sum(diag(WaWa))
    
    arg2 <- (N - p) * trWaWa - trWa ^ 2
    if (arg2 > 0){
      prior_a <- 0.5 * log(arg2)
    }else{
      prior_a <- -Inf
    }
    
  }else{
    prior_a <- -Inf
  }
  
  return(prior_a)
}
