calculate_posterior_inference <- function(li_BAK_results, 
                                          li_simulation_generate)  
  ## Summarises posterior distributions
{

  ## mode n ####
  aVec <- li_BAK_results$aVec
  fpa  <- li_BAK_results$fpa
  fpc1 <- li_BAK_results$fpc1
  c1Vec <- li_BAK_results$c1Vec
  n_mode_a <- aVec[which.max(fpa)]
  n_mode_c1 <- c1Vec[which.max(fpc1)]
  
  ## Credible interval around a as used in simulation? ####
  
  ## based on
  ## https://stats.stackexchange.com/questions/240749/how-to-find-95-credible-interval
  
  # grid of points
  xx <- seq(min(aVec), max(aVec), length.out = 1000)


  #browser()  
  # interpolate function from the sample
  fx <- splinefun(aVec, fpa) # interpolating function
  pxx <- pmax(0, fx(xx)) # normalize so prob >0
  
  cpxx <- cumsum(pxx) / sum(pxx)
  n_lb <- xx[which(cpxx >= 0.05)[1]]   # lower boundary
  n_ub <- xx[which(cpxx >= 0.95)[1]-1] #
  
  # plot(xx, pxx)
  # abline(v = c(n_lb, n_ub) )
  
  bo_cia_sa <- (
              li_simulation_generate$n_a > n_lb & 
              li_simulation_generate$n_a < n_ub
              )
 
  ## Extreme values for a? ####
  bo_a_min <- (n_mode_a < aVec[2] )
  bo_a_max <- (n_mode_a > aVec[length(aVec)-1])
  return(
    c(n_mode_a, bo_cia_sa, bo_a_min, bo_a_max, n_mode_c1)
  )
  
}  