collect_summarise_validation_and_Bay_inference <- function(li_BAK_results, 
                                li_simulation_data, 
                                li_simulation_generate,
                                bo_remove_area_0 = FALSE)
  
## Combines validation statistics and parameter inferences into one
#   vector
{
  
  
  li_val_stats_BAK  <- 
    calculate_validation_stats(
      li_simulation_data = li_simulation_data,
      vn_z_pred = li_BAK_results$z0,
      vn_z_pred_sd = sqrt(ifelse(li_BAK_results$v0<0,0,li_BAK_results$v0)),
      bo_remove_area_0 = bo_remove_area_0
    )  
  
  vn_validation_stats_BAK <- c( unlist(li_val_stats_BAK[3:9]) )
  
  source("calculate_posterior_inference.R") 
  
  vn_post_inference <- 
    calculate_posterior_inference(li_BAK_results = li_BAK_results, 
                                    li_simulation_generate = li_simulation_generate)  
  
  
  return ( 
    c(vn_validation_stats_BAK,vn_post_inference)
  )
} 