create_covariance_objects_1D_sim <- function(li_simulation_data)
{

  
  ## This function creates DMats.a2a and DMats.a2p objects in the
  # global environment, based on the 1D simulation simulation data
  # as provided by prepare_1D_simulation_data
  
  # Note: dp is the only working average covariance method
  str_avg_cov_method <- "dp"
    
  vn_rastered_areas <- li_simulation_data$vn_rastered_areas
  #[1] "Matrix with numbers, square, several distances between areas - for calculating the mean covariance"
  
  # spatial
  # df_rastered_areas <- as.data.frame(vn_rastered_areas)
  # df_rastered_areas <- cbind(df_rastered_areas,0)
  # sp_rastered_areas <- df_rastered_areas; coordinates(sp_rastered_areas) <- c(1,2)
  # remove(df_rastered_areas)
  # class(sp_rastered_areas)
  
  
  vn_area_ids_for_obs_grid <- li_simulation_data$vn_area_ids_for_obs_grid
  #[1] "Vector, same length as numbers of rows of mn_obs_obs_distances, each element indicates the corresponding area"
  
  li_disc_pnts <- tapply(X = vn_rastered_areas, 
                         INDEX=vn_area_ids_for_obs_grid, 
                         FUN = function(vn_rastered_areas){
                           df_rastered_areas <- as.data.frame(vn_rastered_areas)
                           df_rastered_areas <- cbind(df_rastered_areas,0)  
                           # add obsolete coordinate because needed for pstial object
                           sp_rastered_areas <- df_rastered_areas; coordinates(sp_rastered_areas) <- c(1,2)
                           # create the spatial points object
                           return(sp_rastered_areas)
                         }, 
                         simplify=FALSE)
  
  attr(li_disc_pnts, 'description') <- 
    paste( "List, where each element is an sp-class object with grid coordinates ", 
           "(discretisation points) within an area. To be used by DMats4AverageCov.a2a or simular functions")
  
  
  DMats.a2a <<- DMats4AverageCov.a2a(discPts1 = li_disc_pnts, 
                                     method   = str_avg_cov_method 
  )
  
  ## Create the spatial points object of prediction points
  
  
  df_prediction_points <- cbind(li_simulation_data$df_prediction_points,0)  
  # Add obsolete coordinate because needed for spatial object
  sp_prediction_points <- df_prediction_points; coordinates(sp_prediction_points) <- c(1,3) 
  #Note: 2nd column is covariate
  
  DMats.a2p <<- 
    DMats.a2p <- DMats4AverageCov.a2p (points2  = sp_prediction_points,
                                       discPts1 = li_disc_pnts,
                                       method   = str_avg_cov_method 
    )
  gc(verbose = FALSE)  
  invisible()
}  
